///////////////////////////////////////////////////
//Pre-loaded Arno Sketch 
//SW1 = change direction of LED chase
//SW2 = create tone based on photoTran
//POT1 = fade RGB LED.  Turn left for red, right for blue
int tempreg = 0;         
float temperature = 0;    
byte address = 72;
int cycle = 1;
int LEDS[4] = {
  6,7,8,13};
int photoTran = A1;
int piezo = 12;
int POT1 = A0;
int RGB[3] = {
  9,10,11};
int SW1 = A2;
int SW2 = 4;
int thisLED = 0;
long lastPress = 0;
long past = 0;
void setup(){
  Serial.begin(9600);
  Wire.begin();
  tempSetup();
  for(int k = 0; k < 4; k++){
    pinMode(LEDS[k],OUTPUT);
    if(k < 3) pinMode(RGB[k],OUTPUT);
  }
  pinMode(photoTran,INPUT);
  pinMode(POT1,INPUT);
  pinMode(piezo,OUTPUT);
}
void loop(){
  chase();
  checkButton(SW1);
  checkButton(SW2);
  setRGB();
}
///////////////////////////////////////////////
// Additional functions
//check buttons
void checkButton(int button){
  if(digitalRead(button)==LOW && lastPress < millis()){
    if(button == SW1){
      cycle = cycle*-1;
      readTemp();  //read temperature sensor
    }
    if(button == SW2){
      photoTone();
    }
    lastPress = millis() + 1000L;
  }
}
//LED chase
void chase(){
  if(millis() > past + 500L){
    past = millis();
    digitalWrite(LEDS[thisLED],LOW);
    thisLED = thisLED + cycle;
    if(thisLED > 3) thisLED = 0;
    if(thisLED < 0) thisLED = 3;
    digitalWrite(LEDS[thisLED],HIGH);
  }
}
void photoTone(){
  //create tone while SW1 is held down
  while(digitalRead(SW2)==LOW){
  int reading = analogRead(photoTran);
  long frequency = map(reading,0,1023,1000,10000);
  piezoTone(frequency,10);
  }
}
//Piezo tone
void piezoTone(long freq, long duration){
  long aSecond = 1000000;
  long period = aSecond/freq;
  duration = duration*1000;
  duration = duration/period;
  for(long k = 0; k < duration; k++){
    digitalWrite(piezo,HIGH);
    delayMicroseconds(period/2);
    digitalWrite(piezo,LOW);
    delayMicroseconds(period/2);
  }
} 
//set RGB color
void setRGB(){
  int readPot = analogRead(POT1);
  int rLevel = map(readPot,0,342,25,0);
  int bLevel = map(readPot,342,513,0,25);
  if(readPot > 513) bLevel = map(readPot,514,683,25,0);
  int gLevel = map(readPot,683,1024,0,25);
  rLevel = constrain(rLevel,0,25);
  bLevel = constrain(bLevel,0,25);
  gLevel = constrain(gLevel,0,25);
  analogWrite(RGB[0],rLevel);
  analogWrite(RGB[1],bLevel);
  analogWrite(RGB[2],gLevel);
}
//setup temp sensor
void tempSetup(){
  // Set the resolution of the measurement 
  Wire.beginTransmission(address);
  // point to Configuration Register
  Wire.write(0x01);   
  // set the resolution  
  Wire.write(0x60);   
  // ends the command  
  Wire.endTransmission();       
  // points to the Temperature Register  
  Wire.beginTransmission(address);  
  Wire.write(0x00);            
  Wire.endTransmission();  
}
void readTemp(){
   // Receives data from the Temperature Register 
  Wire.requestFrom(address,byte(2)); 
  tempreg = Wire.read();       
  tempreg= tempreg << 8;      
  tempreg |= Wire.read();   
  tempreg = tempreg >> 4;  
  // Calculate the temperature
  temperature =( float ) tempreg / 16;
  // Display the temperature in the Serial Monitor 
  Serial.print(Temp F = );
  Serial.println(temperature*9/5 + 32,2);
}
///////////////////////////////////////////////////
